<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_191) on Wed Jan 30 20:59:46 CET 2019 -->
<title>Board</title>
<meta name="date" content="2019-01-30">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Board";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../com/project/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Board.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../index.html?com/project/Board.html" target="_top">Frames</a></li>
<li><a href="Board.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.project</div>
<h2 title="Class Board" class="title">Class Board</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.project.Board</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">Board</span>
extends java.lang.Object</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../com/project/Board.html#Board--">Board</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#addTile-com.model.Tile-int:A-int-">addTile</a></span>(com.model.Tile&nbsp;tile,
       int[]&nbsp;place,
       int&nbsp;angle)</code>
<div class="block">Use to add a tile on the board.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getAspect-int:A-">getAspect</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to determine the aspect of a field.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>java.util.List&lt;java.lang.Integer&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getBlank--">getBlank</a></span>()</code>
<div class="block">Use to get the list of indexes of fields that do not have a tile on it.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.Integer,com.model.Tile&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getBoard--">getBoard</a></span>()</code>
<div class="block">Use to get the map.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getBoardString--">getBoardString</a></span>()</code>
<div class="block">Method to print a board of Spectrangle, given the properties of the pieces that reside on it.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>com.model.Tile</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getBottom-int:A-">getBottom</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to get the bottom neighbour of a field.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>java.util.List&lt;java.lang.Integer&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getHighBonuses--">getHighBonuses</a></span>()</code>
<div class="block">Use to get the fields with bonuses.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>com.model.Tile</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getLeft-int:A-">getLeft</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to get the left neighbour of a field.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>com.model.Tile</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getRight-int:A-">getRight</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to get the right neighbour of a field.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>com.model.Tile</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#getTop-int:A-">getTop</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to get the top neighbour of a field.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#recovery--">recovery</a></span>()</code>
<div class="block">Use to clear the board.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../com/project/Board.html#removeTile-int:A-">removeTile</a></span>(int[]&nbsp;place)</code>
<div class="block">Use to remove a tile from the board.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Board--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Board</h4>
<pre>public&nbsp;Board()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getAspect-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAspect</h4>
<pre>public&nbsp;int&nbsp;getAspect(int[]&nbsp;place)</pre>
<div class="block">Use to determine the aspect of a field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>0 if the field is facing upwards, 1 if the field is facing downwards</dd>
</dl>
</li>
</ul>
<a name="getRight-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getRight</h4>
<pre>public&nbsp;com.model.Tile&nbsp;getRight(int[]&nbsp;place)</pre>
<div class="block">Use to get the right neighbour of a field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a Tile, the right neighbour of the field at (place[0], place[1]),
         otherwise null</dd>
</dl>
</li>
</ul>
<a name="getLeft-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLeft</h4>
<pre>public&nbsp;com.model.Tile&nbsp;getLeft(int[]&nbsp;place)</pre>
<div class="block">Use to get the left neighbour of a field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a Tile, the left neighbour of the field at (place[0], place[1]),
         otherwise null</dd>
</dl>
</li>
</ul>
<a name="getTop-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTop</h4>
<pre>public&nbsp;com.model.Tile&nbsp;getTop(int[]&nbsp;place)</pre>
<div class="block">Use to get the top neighbour of a field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a Tile, the top neighbour of the field at (place[0], place[1]),
         otherwise null</dd>
</dl>
</li>
</ul>
<a name="getBottom-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBottom</h4>
<pre>public&nbsp;com.model.Tile&nbsp;getBottom(int[]&nbsp;place)</pre>
<div class="block">Use to get the bottom neighbour of a field.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a Tile, the bottom neighbour of the field at (place[0], place[1]),
         otherwise null</dd>
</dl>
</li>
</ul>
<a name="getBlank--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBlank</h4>
<pre>public&nbsp;java.util.List&lt;java.lang.Integer&gt;&nbsp;getBlank()</pre>
<div class="block">Use to get the list of indexes of fields that do not have a tile on it.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list of integers representing the fields that don't a set tile</dd>
</dl>
</li>
</ul>
<a name="getHighBonuses--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHighBonuses</h4>
<pre>public&nbsp;java.util.List&lt;java.lang.Integer&gt;&nbsp;getHighBonuses()</pre>
<div class="block">Use to get the fields with bonuses.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list of integers representing the indexes of fields at which there
         are bonuses</dd>
</dl>
</li>
</ul>
<a name="addTile-com.model.Tile-int:A-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addTile</h4>
<pre>public&nbsp;int&nbsp;addTile(com.model.Tile&nbsp;tile,
                   int[]&nbsp;place,
                   int&nbsp;angle)</pre>
<div class="block">Use to add a tile on the board. There are 3 angles to choose from: TURN_0,
 TURN_120 and TURN_240.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tile</code> - The tile to be set on the spectrangle board</dd>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dd><code>angle</code> - The permutation of the tile to be used</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the number of points obtained by placing the tile, otherwise -1</dd>
</dl>
</li>
</ul>
<a name="removeTile-int:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeTile</h4>
<pre>public&nbsp;boolean&nbsp;removeTile(int[]&nbsp;place)</pre>
<div class="block">Use to remove a tile from the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>place</code> - An array of length 2, with place[0] being the row and place[1]
              being the column of a field</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the tile has been successfully removed, otherwise false</dd>
</dl>
</li>
</ul>
<a name="getBoardString--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBoardString</h4>
<pre>public&nbsp;java.lang.String&nbsp;getBoardString()</pre>
<div class="block">Method to print a board of Spectrangle, given the properties of the pieces that reside on it.

 The arguments to this method together represent the current state of the board. You will need to generate
 these arguments yourself. Each argument needs to be a list of exactly 36 items, representing the 36 fields
 on your board. The index in the list corresponds with the index of the field on the board, as they were
 explained in the slides of the Project Design session in week 6.

 An example of how you would generate the 'values' list is as follows, assuming your board has a List of fields,
 which have an attribute called "value" to represent the value of the piece that is placed in that field, or
 null if there is no piece in that field:

 <pre><code>
 List&lt;Integer&gt; values = new ArrayList&lt;&gt;();
 for(int i = 0; i &lt; this.getFields().size(); i++) {
     values.add(this.getField(i).value);
 }
 </code></pre>

 The Board class has a main method which prints out a board where only
 the first field (index 0) is filled with a piece with value 5 and the colors red on the bottom,
 green on the left and blue on the right. It uses the ArrayLists defined on the top of the file.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>values</code> - The values of all fields on the board. This should be a List of exactly 36 items.
               If the field has no piece on it, the value is 'null', and if it does have a piece
               on it, it is the integer value of the piece.</dd>
<dd><code>vertical</code> - The letters of the vertical colors of all fields on the board. This should be a List of exactly
                 36 items. If the field has no piece on it, the value is 'null', and if it does have a piece
                 on it, the value is a character representing the color of the top or bottom side of the piece.</dd>
<dd><code>left</code> - The letters of the vertical colors of all fields on the board. This should be a List of exactly
             36 items. If the field has no piece on it, the value is 'null', and if it does have a piece
             on it, the value is a character representing the color of the left side of the piece.</dd>
<dd><code>right</code> - The letters of the vertical colors of all fields on the board. This should be a List of exactly
              36 items. If the field has no piece on it, the value is 'null', and if it does have a piece
              on it, the value is a character representing the color of the right side of the piece.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A string representing the state of the board as given.</dd>
</dl>
</li>
</ul>
<a name="getBoard--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBoard</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.Integer,com.model.Tile&gt;&nbsp;getBoard()</pre>
<div class="block">Use to get the map.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>datas, the map between the set tiles and their indexes.</dd>
</dl>
</li>
</ul>
<a name="recovery--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>recovery</h4>
<pre>public&nbsp;void&nbsp;recovery()</pre>
<div class="block">Use to clear the board. IMPORTANT: The lists of neighbours are also emptied.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../com/project/package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Board.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../index.html?com/project/Board.html" target="_top">Frames</a></li>
<li><a href="Board.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
